
      subroutine sd1( neq,t,y,ydot,r,ires,wkres,nwkres )
C   Reaktoreksempel av orden 3
C
C
      integer neq,nwkres,ires
      double precision t,y(neq),ydot(neq),r(neq),wkres(nwkres)
      double precision fx(10),f1,f2,ra
      double precision C11,C21,C22,C31,C32
      PARAMETER (C11=-1.197,C21=0.915,C31=0.282,C22=-0.104,C32=0.104)
      DOUBLE PRECISION XF(3),VF,TF,ALF,BET
      COMMON /SD12BLK/ XF,VF,TF,ALF,BET

      if( ires.eq.-1 )then
          do 10 i=1,neq
             r(i) = -ydot(i)
10        continue
      else
       f1    = y(1)**alf
       f2    = y(2)**bet
       ra    = dexp(-1.0d0/TF)/dexp(-1.0d0)
       fx(1) = -VF*(y(1)-XF(1)) + c11*ra*f1
       fx(2) = -VF*(y(2)-XF(2)) + c21*ra*f1 + c22*ra*f2
       fx(3) = -VF*(y(3)-XF(3)) + c31*ra*f1 + c32*ra*f2

       DO 20 I=1,NEQ
          R(I) = FX(I) - YDOT(I)
20     CONTINUE

      ENDIF

      RETURN
      END


      subroutine sd2( neq,t,y,ydot,r,ires,wkres,nwkres )
C   Reaktoreksempel av orden 3
C
C
      integer neq,nwkres,ires
      double precision t,y(neq),ydot(neq),r(neq),wkres(nwkres)
      double precision fx(10),f1,f2,ra
      double precision C11,C21,C22,C31,C32
      PARAMETER (C11=-1.197,C21=0.915,C31=0.282,C22=-0.104,C32=0.104)
      DOUBLE PRECISION XF(3),VF,TF,ALF,BET
      COMMON /SD12BLK/ XF,VF,TF,ALF,BET

      if( ires.eq.-1 )then
          do 10 i=1,neq
             r(i) = -ydot(i)
10        continue
      else
       f1    = y(1)**alf
       f2    = y(2)**bet
       ra    = dexp(-1.0d0/TF)/dexp(-1.0d0)
       fx(1) = -VF*(y(1)-XF(1)) + c11*ra*f1
       fx(2) = -VF*(y(2)-XF(2)) + c21*ra*f1 + c22*ra*f2
       fx(3) = -VF*(y(3)-XF(3)) + c31*ra*f1 + c32*ra*f2

       DO 20 I=1,NEQ
          R(I) = FX(I) - YDOT(I)
20     CONTINUE

      ENDIF

      RETURN
      END

      subroutine sd3( neq,t,y,ydot,r,ires,wkres,nwkres )
C   Reaktoreksempel av orden 3
C
C
      integer neq,nwkres,ires
      double precision t,y(neq),ydot(neq),r(neq),wkres(nwkres)
C.. Local parameters
      integer i
      double precision fx(1200),f1,f2,ra
      double precision C11,C21,C22,C31,C32
      PARAMETER (C11=-1.197,C21=0.915,C31=0.282,C22=-0.104,C32=0.104)
C. Common from init.f
      DOUBLE PRECISION XF(1200),VF,TF,ALF,BET
      COMMON /SD3BLK/ XF,VF,TF,ALF,BET

      if( ires.eq.-1 )then
          do 10 i=1,neq
             r(i) = -ydot(i)
10        continue
      else

       f1    = y(1)**alf
       f2    = y(2)**bet
       ra    = dexp(-1.0d0/TF)/dexp(-1.0d0)

       if (neq.eq.3) then
        fx(1) = -VF*(y(1)-XF(1)) + c11*ra*f1
        fx(2) = -VF*(y(2)-XF(2)) + c21*ra*f1 + c22*ra*f2
        fx(3) = -VF*(y(3)-XF(3)) + c31*ra*f1 + c32*ra*f2
       else
        fx(1) = -VF*(y(1)-XF(1)) + c11*ra*f1
        fx(2) = -VF*(y(2)-XF(2)) + c21*ra*f1 + c22*ra*f2

        do 190 i = 1,neq-2
           fx(i+2) = -VF*(y(i+2)-XF(i+2)) + c31*ra*f1 + c32*ra*f2
190     continue
       endif

       DO 20 I=1,NEQ
          R(I) = FX(I) - YDOT(I)
20     CONTINUE

      ENDIF

      RETURN
      END

