      DOUBLE PRECISION FUNCTION DZASUM(N,ZX,INCX)
C
C     TAKES THE SUM OF THE ABSOLUTE VALUES.
C     JACK DONGARRA, 3/11/78.
C
      COMPLEX*16 ZX(1)
      DOUBLE PRECISION STEMP,DCABS1
C
      DZASUM = 0.0D0
      STEMP = 0.0D0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENTS NOT EQUAL TO 1
C
      IX = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      DO 10 I = 1,N
        STEMP = STEMP + DCABS1(ZX(IX))
        IX = IX + INCX
   10 CONTINUE
      DZASUM = STEMP
      RETURN
C
C        CODE FOR INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        STEMP = STEMP + DCABS1(ZX(I))
   30 CONTINUE
      DZASUM = STEMP
      RETURN
      END
