      SUBROUTINE  ZDROT (N,ZX,INCX,ZY,INCY,C,S)
C
C     APPLIES A PLANE ROTATION, WHERE THE COS AND SIN (C AND S) ARE
C     DOUBLE PRECISION AND THE VECTORS ZX AND ZY ARE COMPLEX*16.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      COMPLEX*16 ZX(1),ZY(1),ZTEMP
      DOUBLE PRECISION C,S
      INTEGER I,INCX,INCY,IX,IY,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
C         TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        ZTEMP = C*ZX(IX) + S*ZY(IY)
        ZY(IY) = C*ZY(IY) - S*ZX(IX)
        ZX(IX) = ZTEMP
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C       CODE FOR BOTH INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        ZTEMP = C*ZX(I) + S*ZY(I)
        ZY(I) = C*ZY(I) - S*ZX(I)
        ZX(I) = ZTEMP
   30 CONTINUE
      RETURN
      END
