      SUBROUTINE CAXPY(N,CA,CX,INCX,CY,INCY)                            00000010
C                                                                       00000020
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.                            00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      COMPLEX CX(1),CY(1),CA                                            00000060
      INTEGER I,INCX,INCY,IX,IY,N                                       00000070
C                                                                       00000080
      IF(N.LE.0)RETURN                                                  00000090
      IF (ABS(REAL(CA)) + ABS(AIMAG(CA)) .EQ. 0.0 ) RETURN              00000100
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000110
C                                                                       00000120
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                00000130
C          NOT EQUAL TO 1                                               00000140
C                                                                       00000150
      IX = 1                                                            00000160
      IY = 1                                                            00000170
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000180
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000190
      DO 10 I = 1,N                                                     00000200
        CY(IY) = CY(IY) + CA*CX(IX)                                     00000210
        IX = IX + INCX                                                  00000220
        IY = IY + INCY                                                  00000230
   10 CONTINUE                                                          00000240
      RETURN                                                            00000250
C                                                                       00000260
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            00000270
C                                                                       00000280
   20 DO 30 I = 1,N                                                     00000290
        CY(I) = CY(I) + CA*CX(I)                                        00000300
   30 CONTINUE                                                          00000310
      RETURN                                                            00000320
      END                                                               00000330
