      SUBROUTINE  CSCAL(N,CA,CX,INCX)                                   00000010
C                                                                       00000020
C     SCALES A VECTOR BY A CONSTANT.                                    00000030
C     JACK DONGARRA, LINPACK,  3/11/78.                                 00000040
C                                                                       00000050
      COMPLEX CA,CX(1)                                                  00000060
      INTEGER I,INCX,N,NINCX                                            00000070
C                                                                       00000080
      IF(N.LE.0)RETURN                                                  00000090
      IF(INCX.EQ.1)GO TO 20                                             00000100
C                                                                       00000110
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000120
C                                                                       00000130
      NINCX = N*INCX                                                    00000140
      DO 10 I = 1,NINCX,INCX                                            00000150
        CX(I) = CA*CX(I)                                                00000160
   10 CONTINUE                                                          00000170
      RETURN                                                            00000180
C                                                                       00000190
C        CODE FOR INCREMENT EQUAL TO 1                                  00000200
C                                                                       00000210
   20 DO 30 I = 1,N                                                     00000220
        CX(I) = CA*CX(I)                                                00000230
   30 CONTINUE                                                          00000240
      RETURN                                                            00000250
      END                                                               00000260
