      SUBROUTINE  CSSCAL(N,SA,CX,INCX)                                  00000010
C                                                                       00000020
C     SCALES A COMPLEX VECTOR BY A REAL CONSTANT.                       00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      COMPLEX CX(1)                                                     00000060
      REAL SA                                                           00000070
      INTEGER I,INCX,N,NINCX                                            00000080
C                                                                       00000090
      IF(N.LE.0)RETURN                                                  00000100
      IF(INCX.EQ.1)GO TO 20                                             00000110
C                                                                       00000120
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000130
C                                                                       00000140
      NINCX = N*INCX                                                    00000150
      DO 10 I = 1,NINCX,INCX                                            00000170
        CX(I) = CMPLX(SA*REAL(CX(I)),SA*AIMAG(CX(I)))                   00000180
   10 CONTINUE                                                          00000200
      RETURN                                                            00000210
C                                                                       00000220
C        CODE FOR INCREMENT EQUAL TO 1                                  00000230
C                                                                       00000240
   20 DO 30 I = 1,N                                                     00000250
        CX(I) = CMPLX(SA*REAL(CX(I)),SA*AIMAG(CX(I)))                   00000260
   30 CONTINUE                                                          00000270
      RETURN                                                            00000280
      END                                                               00000290
