      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)                        00000010
C                                                                       00000020
C     TAKES THE SUM OF THE ABSOLUTE VALUES.                             00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      DOUBLE PRECISION DX(1),DTEMP                                      00000060
      INTEGER I,INCX,M,MP1,N,NINCX                                      00000070
C                                                                       00000080
      DASUM = 0.0D0                                                     00000090
      DTEMP = 0.0D0                                                     00000100
      IF(N.LE.0)RETURN                                                  00000110
      IF(INCX.EQ.1)GO TO 20                                             00000120
C                                                                       00000130
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000140
C                                                                       00000150
      NINCX = N*INCX                                                    00000160
      DO 10 I = 1,NINCX,INCX                                            00000170
        DTEMP = DTEMP + DABS(DX(I))                                     00000180
   10 CONTINUE                                                          00000190
      DASUM = DTEMP                                                     00000200
      RETURN                                                            00000210
C                                                                       00000220
C        CODE FOR INCREMENT EQUAL TO 1                                  00000230
C                                                                       00000240
C                                                                       00000250
C        CLEAN-UP LOOP                                                  00000260
C                                                                       00000270
   20 M = MOD(N,6)                                                      00000280
      IF( M .EQ. 0 ) GO TO 40                                           00000290
      DO 30 I = 1,M                                                     00000300
        DTEMP = DTEMP + DABS(DX(I))                                     00000310
   30 CONTINUE                                                          00000320
      IF( N .LT. 6 ) GO TO 60                                           00000330
   40 MP1 = M + 1                                                       00000340
      DO 50 I = MP1,N,6                                                 00000350
        DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I + 1)) + DABS(DX(I + 2)) 00000360
     *  + DABS(DX(I + 3)) + DABS(DX(I + 4)) + DABS(DX(I + 5))           00000370
   50 CONTINUE                                                          00000380
   60 DASUM = DTEMP                                                     00000390
      RETURN                                                            00000400
      END                                                               00000410
