      DOUBLE PRECISION FUNCTION DZASUM(N,ZX,INCX)                       00000010
C                                                                       00000020
C     TAKES THE SUM OF THE ABSOLUTE VALUES.                             00000030
C     JACK DONGARRA, 3/11/78.                                           00000040
C                                                                       00000050
      COMPLEX*16 ZX(1)                                                  00000060
      DOUBLE PRECISION STEMP,DCABS1                                     00000070
C                                                                       00000080
      DZASUM = 0.0D0                                                    00000090
      STEMP = 0.0D0                                                     00000100
      IF(N.LE.0)RETURN                                                  00000110
      IF(INCX.EQ.1)GO TO 20                                             00000120
C                                                                       00000130
C        CODE FOR INCREMENTS NOT EQUAL TO 1                             00000140
C                                                                       00000150
      IX = 1                                                            00000160
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000170
      DO 10 I = 1,N                                                     00000180
        STEMP = STEMP + DCABS1(ZX(IX))                                  00000190
        IX = IX + INCX                                                  00000200
   10 CONTINUE                                                          00000210
      DZASUM = STEMP                                                    00000220
      RETURN                                                            00000230
C                                                                       00000240
C        CODE FOR INCREMENTS EQUAL TO 1                                 00000250
C                                                                       00000260
   20 DO 30 I = 1,N                                                     00000270
        STEMP = STEMP + DCABS1(ZX(I))                                   00000280
   30 CONTINUE                                                          00000290
      DZASUM = STEMP                                                    00000300
      RETURN                                                            00000310
      END                                                               00000320
