      INTEGER FUNCTION ISAMAX(N,SX,INCX)                                00000010
C                                                                       00000020
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.            00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      REAL SX(1),SMAX                                                   00000060
      INTEGER I,INCX,IX,N                                               00000070
C                                                                       00000080
      ISAMAX = 0                                                        00000090
      IF( N .LT. 1 ) RETURN                                             00000100
      ISAMAX = 1                                                        00000110
      IF(N.EQ.1)RETURN                                                  00000120
      IF(INCX.EQ.1)GO TO 20                                             00000130
C                                                                       00000140
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000150
C                                                                       00000160
      IX = 1                                                            00000170
      SMAX = ABS(SX(1))                                                 00000180
      IX = IX + INCX                                                    00000190
      DO 10 I = 2,N                                                     00000200
         IF(ABS(SX(IX)).LE.SMAX) GO TO 5                                00000210
         ISAMAX = I                                                     00000220
         SMAX = ABS(SX(IX))                                             00000230
    5    IX = IX + INCX                                                 00000240
   10 CONTINUE                                                          00000250
      RETURN                                                            00000260
C                                                                       00000270
C        CODE FOR INCREMENT EQUAL TO 1                                  00000280
C                                                                       00000290
   20 SMAX = ABS(SX(1))                                                 00000300
      DO 30 I = 2,N                                                     00000310
         IF(ABS(SX(I)).LE.SMAX) GO TO 30                                00000320
         ISAMAX = I                                                     00000330
         SMAX = ABS(SX(I))                                              00000340
   30 CONTINUE                                                          00000350
      RETURN                                                            00000360
      END                                                               00000370
