      INTEGER FUNCTION IZAMAX(N,ZX,INCX)                                00000010
C                                                                       00000020
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.            00000030
C     JACK DONGARRA, 3/11/78.                                           00000040
C                                                                       00000050
      COMPLEX*16 ZX(1)                                                  00000060
      DOUBLE PRECISION SMAX                                             00000070
      COMPLEX*16 ZDUM                                                   00000080
      DOUBLE PRECISION DCABS1                                           00000090
C                                                                       00000100
      IZAMAX = 1                                                        00000110
      IF(N.LE.1)RETURN                                                  00000120
      IF(INCX.EQ.1)GO TO 20                                             00000130
C                                                                       00000140
C        CODE FOR INCREMENTS NOT EQUAL TO 1                             00000150
C                                                                       00000160
      IX = 1                                                            00000170
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000180
      SMAX = DCABS1(ZX(1))                                              00000190
      IX = IX + INCX                                                    00000200
      DO 10 I = 2,N                                                     00000210
         IF(DCABS1(ZX(IX)).LE.SMAX) GO TO 5                             00000220
         IZAMAX = IX                                                    00000230
         SMAX = DCABS1(ZX(IX))                                          00000240
    5    IX = IX + INCX                                                 00000250
   10 CONTINUE                                                          00000260
      RETURN                                                            00000270
C                                                                       00000280
C        CODE FOR INCREMENTS EQUAL TO 1                                 00000290
C                                                                       00000300
   20 SMAX = DCABS1(ZX(1))                                              00000310
      DO 30 I = 2,N                                                     00000320
         IF(DCABS1(ZX(I)).LE.SMAX) GO TO 30                             00000330
         IZAMAX = I                                                     00000340
         SMAX = DCABS1(ZX(I))                                           00000350
   30 CONTINUE                                                          00000360
      RETURN                                                            00000370
      END                                                               00000380
