      SUBROUTINE  SROT (N,SX,INCX,SY,INCY,C,S)                          00000010
C                                                                       00000020
C     APPLIES A PLANE ROTATION.                                         00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      REAL SX(1),SY(1),STEMP,C,S                                        00000060
      INTEGER I,INCX,INCY,IX,IY,N                                       00000070
C                                                                       00000080
      IF(N.LE.0)RETURN                                                  00000090
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000100
C                                                                       00000110
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL       00000120
C         TO 1                                                          00000130
C                                                                       00000140
      IX = 1                                                            00000150
      IY = 1                                                            00000160
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000170
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000180
      DO 10 I = 1,N                                                     00000190
        STEMP = C*SX(IX) + S*SY(IY)                                     00000200
        SY(IY) = C*SY(IY) - S*SX(IX)                                    00000210
        SX(IX) = STEMP                                                  00000220
        IX = IX + INCX                                                  00000230
        IY = IY + INCY                                                  00000240
   10 CONTINUE                                                          00000250
      RETURN                                                            00000260
C                                                                       00000270
C       CODE FOR BOTH INCREMENTS EQUAL TO 1                             00000280
C                                                                       00000290
   20 DO 30 I = 1,N                                                     00000300
        STEMP = C*SX(I) + S*SY(I)                                       00000310
        SY(I) = C*SY(I) - S*SX(I)                                       00000320
        SX(I) = STEMP                                                   00000330
   30 CONTINUE                                                          00000340
      RETURN                                                            00000350
      END                                                               00000360
