      SUBROUTINE ZROTG(CA,CB,C,S)                                       00000010
      COMPLEX*16 CA,CB,S                                                00000020
      DOUBLE PRECISION C                                                00000030
      DOUBLE PRECISION NORM,SCALE                                       00000040
      COMPLEX*16 ALPHA                                                  00000050
      IF ( ZABS(CA) .NE. 0.0D0) GO TO 10                                00000060
         C = 0.0D0                                                      00000070
         S = (1.0D0,0.0D0)                                              00000080
         CA = CB                                                        00000090
         GO TO 20                                                       00000100
   10 CONTINUE                                                          00000110
         SCALE =  ZABS(CA) +  ZABS(CB)                                  00000120
         NORM = SCALE*DSQRT(( ZABS(CA/DCMPLX(SCALE,0.0D0)))**2 +        00000130
     *                      ( ZABS(CB/DCMPLX(SCALE,0.0D0)))**2)         00000140
         ALPHA = CA / ZABS(CA)                                          00000150
         C =  ZABS(CA) / NORM                                           00000160
         S = ALPHA * DCONJG(CB) / NORM                                  00000170
         CA = ALPHA * NORM                                              00000180
   20 CONTINUE                                                          00000190
      RETURN                                                            00000200
      END                                                               00000210
