      SUBROUTINE  ZSCAL(N,ZA,ZX,INCX)                                   00000010
C                                                                       00000020
C    SCALES A VECTOR BY A CONSTANT.                                     00000030
C    JACK DONGARRA, 3/11/78.                                            00000040
C                                                                       00000050
      COMPLEX*16 ZA,ZX(1)                                               00000060
      IF(N.LE.0)RETURN                                                  00000070
      IF(INCX.EQ.1)GO TO 20                                             00000080
C                                                                       00000090
C        CODE FOR INCREMENTS NOT EQUAL TO 1                             00000100
C                                                                       00000110
      IX = 1                                                            00000120
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000130
      DO 10 I = 1,N                                                     00000140
        ZX(IX) = ZA*ZX(IX)                                              00000150
        IX = IX + INCX                                                  00000160
   10 CONTINUE                                                          00000170
      RETURN                                                            00000180
C                                                                       00000190
C        CODE FOR INCREMENTS EQUAL TO 1                                 00000200
C                                                                       00000210
   20 DO 30 I = 1,N                                                     00000220
        ZX(I) = ZA*ZX(I)                                                00000230
   30 CONTINUE                                                          00000240
      RETURN                                                            00000250
      END                                                               00000260
