C SOLUTION OF FLAME PROBLEM WITH EXACT SOL. REMESH + SPKEEL DISC .
C***********************************************************************
C
      INTEGER NPTS, NPDE, NIWJAC, NRMESH, NOP, ICOUNT, ITOL, NXI, M,
     -        IBAND, JACPVT(166),IDEV, ITRACE, I, NWKMON, NY2DIM,
     -        INFORM(100), NRW, NWKJAC, NWKRES, NEQ, IPMINF, ISET, NV,
     -        LINALG, NEQMAX
      DOUBLE PRECISION  X(81), Y(81), RWORK(900), TEND, TINC,
     -        T, TOUT, ATOL, RTOL, WKMON(1), WKRES(600), YEXACT(81),
     -        WKJAC(900), YSAVE(81,8),YDOT(81), CONST, STPRAT, XI
      LOGICAL REMESH
      CHARACTER*6 SNORM
      EXTERNAL PREPJB, SOLSB, STHETB, SKLRES, SPRJAC, MVMESH
C COMMON MESHIN USED BY SUBROUTINES INITSK AND MVMESH
      COMMON /MESHIN/ CONST, STPRAT, IPMINF, NOP
C COMMON MESHTI USED BY SUBROUTINE MVMESH FOR REMESHING IN TIME INFO
      COMMON /MESHTI/ TOUT, REMESH, NRMESH, ICOUNT
      COMMON /SDEV2/  ITRACE,IDEV
C SET OFF UNDERFLOWS              ( I.B.M. ONLY )
C     CALL ERRSET(208,256,-1,-1,0)
C
C PDE AND SPACE SIZES: MAXNPT USE FOR ARRAY DIMENSIONS IN MVMESH MONITOR
      MAXNPT=81
C IF USE REMESH OPTION NOP=0 THEN NPTS AND NEQ CHANGED BY REMESHING
      NPTS = 41
      NPDE = 1
C
C   O.D.E. INFO
      NV = 0
      NXI = 0
      XI = 0.0D0
C
C WORK SPACE DIMENSIONS:
C RESWK IS RESIDUAL WORKSPACE USED BY SKEEL ROUTINE AND SO HAS TO BE
C OF SIZE  NPTS*(NPDE+5)+17*NPDE  4 * MAXNPT
C FOR VARIABLE NO. MESH POINTS SET NPTS=MAXNPT=81, SO NRWK=SAY 500
      NRW = 900
      NWKRES = 600
      IDEV = 4
      ITRACE = 1
C   NEQ = NPDE*NPTS  + NV SET LATER SINCE INITSK CAN CHANGE NPTS
      NEQMAX=NPDE*MAXNPT + NV
      NWKJAC = 900
      NWKMON = 1
C NWKDRV = DIMENSION OF ARRAY WORK = SPRINT RWORK (1ST 20 WORDS RESERVED
      NRW = 21 + 3*NEQMAX
      NIWJAC = 166
C
C TIME INTEGRATION METHOD IS THETB INTEGRATOR .
      SNORM = 'L2NORM'
C TO USE ARRAYS FOR ATOL,RTOL WILL NEED SOME MODS FOR VARIABLE MESH NOS.
      ITOL = 1
C  ABS : THE ABSOLUTE LOCAL ERROR TOLERANCE.
C  REL : THE RELATIVE LOCAL ERROR TOLERANCE.
      ATOL = 1.0D-4
      RTOL = 1.0D-4
      T = 0.0D0
      TEND=10.0D0
C SPRINT RETURNS TO MAIN PROGRAM EVERY TIME INTERVAL OF TINC TO OUTPUT.
      TINC=1.0D0
      TOUT = TINC
C
C SPACE MESH INFO.:
C  M     : INTEGER PARAMETER SPECIFYING WHETHER THE P.D.E IS IN
C          CARTESIAN (M=0) OR POLAR (M > 0) CO-ORDINATES.
      M = 0
C INITIAL MESH SPACING X() IS EVENLY SPACED .
C INITSK PROVIDES FINAL ADAPTIVE MESH IF REMESH OPTION SET.
      X(1)=0.0D0
      X(NPTS) = 1.20D2
      DO 10 I = 2, NPTS-1
 10      X(I)=X(1)+(I-1)*(X(NPTS)-X(1))/(NPTS-1)
C
C REMESH INFO (VARIABLE NO. POINTS OPTION THEN SET NOP=0 ELSE NOP=NPTS)
      REMESH = .TRUE.
      NOP=NPTS
      CONST= 2.0D0 / (NPTS-1)
      STPRAT=3.0D0
      IPMINF=0
C NRMESH DICTATES HOW OFTEN REMESH :
C =1 THEN REMESHES EVERY TIME STEP WHEN MONITOR ROUTINE CALLED
C =2                     2ND TIME STEP, ETC....
C =0 THEN REMESHES AT CURRENT TIME TOUT BY THE CALL TO MONITOR WITH
C    INFORM(2)=4 AND WORK(1) SET TO CURRENT TOUT. IF THE SOLUTION
C    PROFILE CHANGES RAPIDLY FOR CERTAIN T THEN SET TOUT ACCORDINGLY.
C
      NRMESH=2
C ICOUNT USED TO COUNT UP TO NRMESH SO JUST INITIALISE TO ZERO
      ICOUNT=0
C IF HMAX=WORK(6) IS LARGE THEN NRMESH*HMAX MAY BE TOO LARGE
C FOR REMESHING PURPOSES SO SET ACCORDINGLY
      RWORK(5)=0.0D0
      RWORK(6)=0.2D0
      RWORK(7)=0.0D0
C
C INITIALISE THE DISCRETISATION WORKSPACE , USE PADRMS TO GET INITIAL
C MESH  AND SET UP THE BAND INFO. NEEDED BY BANDED MATRIX ROUTINES.
        ISET = 1
        CALL INITSK( NEQ, NPDE, NPTS, X, Y, WKRES, NWKRES, M, T, IBAND,
     1               ISET, REMESH, MAXNPT, NV, NXI, XI)
        IF(ISET .LT. 0)GOTO 106
        NEQ=NPDE*NPTS
        JACPVT(1) = IBAND
        JACPVT(2) = IBAND
C
C  PASS THE INTEGRATION PARAMETERS INTO THE ARRAY INFORM
C
      INFORM(1) = 0
C   INFORM(2) = 1  UNLESS SET BELOW FOR REMESH OPTION NRMESH=0
      INFORM(2) = 1
      INFORM(3) = 1
      DO 50 I = 4,14
50       INFORM(I) = 0
      NY2DIM = 8
      ISET = 0
      CALL THBSET( NY2DIM, ISET, .FALSE., .FALSE. , 0.55D0)
      IF(ISET .LT. 0)GO TO 1000
C
C SET UP THE PARAMETERS FOR THE LINEAR ALGEBRA INITIALISATION CALL
C FOR VARIABLE NO. OF PTS NEED TO CALL WITH NEQMAX NOT INITIAL NEQN
C
      LINALG = 1
      CALL MATSET(LINALG, NEQMAX, JACPVT,JACPVT(2), NWKJAC, NIWJAC,ISET)
      IF(ISET .LT. 0)GOTO 1000
C**********************************************************************
C    CALL SPRINT WITH MAX NO EQNS SET TO NYSAVE=MAXNPT*NPDE
C
C TIME LOOP:
100   IF(REMESH.AND.NRMESH.EQ.0)THEN
          INFORM(2)=4
          RWORK(1)=TOUT
      ENDIF
C
C    STHETB METHOD WITH BANDED MATRIX ROUTINES
        CALL SPRINT( NEQ, T, TOUT, Y, YDOT, RWORK, NRW, RTOL, ATOL,
     1       ITOL, INFORM, SNORM, SKLRES, WKRES, NWKRES, STHETB, YSAVE,
     2       NEQMAX, PREPJB, WKJAC, NWKJAC, JACPVT, SPRJAC, SOLSB,
     3       MVMESH, WKMON, NWKMON)
C
C   PASS STATS BACK ACROSS AND RECOVER THE MESH USED IN INTEGRATION.
C
        ISET = 2
        CALL INITSK( NEQ, NPDE, NPTS, X, Y, WKRES, NWKRES, M, T, IBAND,
     1                ISET, REMESH, MAXNPT, NV, NXI, XI)
C
C WRITE SOLUTION AND MEASURE THE ERROR.
        WRITE(IDEV,81)TOUT,INFORM(1)
81      FORMAT('  SOL AT',D12.4,'         INFORM(1) =',I3)
        WRITE(IDEV,82)(X(I),I = 1,NPTS,5)
82      FORMAT(' MESH',10D10.3/)
        WRITE(IDEV,83)(Y(I),I=1,NPTS,5)
83      FORMAT(' SOL ',10D10.3/)
        CALL EXACT ( TOUT, NPDE, NPTS, X, YEXACT)
        CALL L2ERNM( TOUT, NPDE, NPTS, Y, YEXACT)
106     CONTINUE
        IF(INFORM(1) .EQ. 2)THEN
           IF(TOUT .GE. TEND)GOTO 1000
           TOUT = TOUT + TINC
           GOTO 100
        END IF
 1000 CONTINUE
       WRITE(IDEV,270)INFORM(7),INFORM(8), INFORM(11), INFORM(6)
 270  FORMAT(' FUN=',I5,' IJAC=',I5,' NITER=',I5,' NSTEPS=',I5)
      STOP
      END
C**********************************************************************
C        PROBLEM DESCRIPTION ROUTINES
C**********************************************************************
C EXACT SOLUTION
       SUBROUTINE EXACT( TIME, NPDE, NPTS, X, U)
C      ROUTINE FOR P.D.E. EXACT VALUES  (IF KNOWN)
       INTEGER NPDE, NPTS
       DOUBLE PRECISION X(NPTS), U(NPDE,NPTS), TIME, P
       P=DSQRT(2.0D0)*0.5D0
       DO 10 I = 1,NPTS
 10       U(1,I) = 1.0D0/(1.0D0+DEXP(P*(X(I)-P*TIME)))
       RETURN
       END
       SUBROUTINE UINIT( NPDE, NPTS, X, U)
C      ROUTINE FOR P.D.E. INITIAL VALUES.
       INTEGER NPDE, NPTS
       DOUBLE PRECISION X(NPTS), U(NPDE,NPTS), TIME
       TIME=0.0D0
       CALL EXACT(TIME,NPDE,NPTS,X,U)
       RETURN
       END
C
       SUBROUTINE SPDEF1(T,X, NPDE, U, DUDX,C,Q,R, NV, V,VD, IRES)
C
C  ROUTINE TO DESCRIBE THE BODY OF THE P.D.E.
C
C   C (X,T, U, U  ) U  =  ( R (X,T, U, U  ) )  - Q (X,T, U, U  )
C    I      -  - X  -T       I      -  - X   X    I      -  - X
C
C FOR MIXED ODES/PDES C AND Q CAN ALSO BE FUNCTIONS OF V AND VD WHILE
C R MAY ALSO DEPEND ON V .
       INTEGER NPDE, I, J, NV, IRES
       DOUBLE PRECISION T, X, U(NPDE),DUDX(NPDE),
     1    C(NPDE,NPDE), Q(NPDE), R(NPDE), V ,VD
          DO 9 J = 1,NPDE
             C(J,J) = 1.0D0
             R(J) = DUDX(J)
 9        Q(J) = -U(J)*(1.0D0-U(J))*U(J)
 10    CONTINUE
       RETURN
       END
      SUBROUTINE BNDR(T, BETA, GAMMA,U,UX, NPDE, LEFT, NV, V, VD, IRES)
C
C SPECIFIES BOUNDARY CONDITIONS OF THE FORM
C
C          BETA(I,T)*R(X,T,U,U ) = GAMMA(I,T,U)  AT X = A OR B
C                             X
C THE FORM OF THE FLUX FUNCTION IS SPECIFIED IN SPDEF1
      INTEGER NPDE, I, NV, IRES
      DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), UX(NPDE),
     1       V, VD, EXU
      LOGICAL LEFT
C DIRICHLET B.C.S AT BOTH ENDS USING EXACT SOLUTION
          BETA(1) = 0.0D0
       IF(LEFT) THEN
          CALL EXACT(T,NPDE,1,0.0D0,EXU)
          GAMMA(1) = EXU - U(1)
       ELSE
          CALL EXACT(T,NPDE,1,1.2D2,EXU)
          GAMMA(1) = EXU - U(1)
       END IF
      RETURN
      END
C
C     DUMMY ROUTINES FOR NON-EXISTANT O.D.E. PART OF THE PROBLEM
C
      SUBROUTINE SODEFN
      RETURN
      END
      SUBROUTINE SVINIT
      RETURN
      END
C**********************************************************************
      SUBROUTINE EVNRMF( TIME, NIP, NPDE, X, U, R, MAXNPT, FMON)
C**********************************************************************
C     EXAMPLE MONITOR FUNCTION ROUTINE FOR REMESHING.
C     R(J,I) CONTAINS THE FLUX FOR JTH P.D.E. AT POINT Y(I)
C        WHERE Y(1) = X(1) , Y(NIP+1) = X(NIP)
C              Y(I) =(X(I+1) - X(I)) * 0.5   I = 2,..., NIP
C     THE MONITOR FUNCTION IS RETURNED IN THE ARRAY FMON
C
      INTEGER NIP, NPDE, MAXNPT, I, J, K, L
      DOUBLE PRECISION U(NPDE,1), X(NIP), SUM,FMON(NIP), TIME,
     1                 R(NPDE,1),  DRDX, H
      DO 10 I=1,NIP
        K = MAX0(1,I-1)
        L = MIN0(NIP,I+1)
        H = (X(L) - X(K)) * 0.5D0
        SUM=0.0D0
        DO 5 J=1,NPDE
C 1ST DERIV
C          DRDX = R(J,I)
C 2ND DERIV
           DRDX = (R(J,I+1) - R(J,I)) / H
    5      SUM = SUM + DRDX**2
        FMON(I)=DSQRT(SUM)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE L2ERNM( T, NPDE, NPTS, U, UEX)
C COMPUTES R.M.S. L2 ERROR NORM AND LINF NORM
      INTEGER I, IDIMAX, NPDE ,NPTS, ITRACE, IDEV
      DOUBLE PRECISION T, U(NPTS), UEX(NPTS), DIF, ERL2, ERLINF
      COMMON / SDEV2/ ITRACE, IDEV
      ERL2=0.0D0
      ERLINF=0.0D0
      IDIMAX=1
      DO 10 I =1,NPTS
         DIF=DABS( U(I)-UEX(I) )
         ERL2=ERL2+DIF*DIF
         IF(DIF.LT.ERLINF)GO TO 10
         ERLINF=DIF
         IDIMAX=I
   10 CONTINUE
      ERL2=DSQRT(ERL2)/DFLOAT(NPTS)
      WRITE(IDEV,99)ERL2,ERLINF,IDIMAX
   99 FORMAT('0 R.M.S L2 AND LINF NORMS = ',2D12.4,
     1      ' MAXIMUM AT POINT ',I3)
      RETURN
      END
