      real function scl1(z)
      complex z
c
c     *** purpose:
c
c     scl1 is a real function subprogram which returns the l1-type
c     magnitude of a complex number z, i.e., the number
c     abs(re(z))+abs(im(z))  where re(z) and im(z) are the real and
c     imaginary parts, respectively, of z.
c
c     this version dated may 1980.
c     alan j. laub, university of southern california.
c
c     fortran functions called:
c
      real abs,aimag,real
c
      scl1 = abs(real(z))+abs(aimag(z))
      return
      end
