	subroutine zcmprs (m,n,p,af,bf,eps,nu,rank,sum,work,max)
	logical zero
	integer m,n,p,nu,rank,max
	integer mm,nn,pp,ro,sigma,mu,numu,mnu,numu1,mnu1,nu1
	integer i,j,i1,j1,i0
	real*8 af(max,*),bf(max,*),sum(*),work(*),eps,s
	mm = m
	nn = n
	pp = p
	do 10 j=1,mm
	do 10 i=1,nn
	bf(i,j) = af(i,j+nn)
   10	continue
	do 20 j=1,nn
	do 20 i=1,nn
	bf(i,j+mm) = af(i,j)
   20	continue
	do 30 j=1,mm
	do 30 i=nn+1,nn+pp
	bf(i,j) = af(i,j+nn)
   30	continue
	do 40 j=1,nn
	do 40 i=nn+1,nn+pp
	bf(i,j+mm) = af(i,j)
   40	continue
	ro = pp
	sigma = 0
	call reduc (bf,max,mm,nn,pp,eps,ro,sigma,mu,nu,sum,work)
	rank = mu
	if (nu .eq. 0) return
	numu = nu + mu
	mnu = mm + nu
	numu1 = numu + 1
	mnu1 = mnu + 1
	do 50 i=1,numu
	    do 50 j=1,mnu
		af(mnu1-j,numu1-i) = bf(i,j)
   50	continue
	if (mu .ne. mm) then
	    pp = mm
	    nn = nu
	    mm = mu
	    ro = pp - mm
	    sigma = mm
	    call reduc (af,max,mm,nn,pp,eps,ro,sigma,mu,nu,sum,work)
	    if (nu .eq. 0) return
	    mnu = mm + nu
	endif
	do 70 i=1,nu
	    do 60 j=1,mnu
		bf(i,j) = 0.0
   60	    continue
	    bf(i,i+mm) = 1.0
   70	continue
	if (rank .eq. 0) return
	nu1 = nu + 1
	i1 = nu + mu
	j1 = mnu + 1
	i0 = mm
	do 90 i=1,mm
	    i0 = i0 - 1
	    do 80 j=1,nu1
		work(j) = af(i1,i0+j)
   80	    continue
	    call housh (work,nu1,nu1,eps,zero,s)
	    call tr2 (af,max,work,s,1,i1,i0,nu1)
	    call tr2 (bf,max,work,s,1,nu,i0,nu1)
	    i1 = i1 - 1
   90	continue
	return
	end
	subroutine reduc (abcd,mdima,m,n,p,eps,ro,sigma,mu,nu,sum,work)
	integer mdima,m,n,p,sigma,mu,nu
	integer mnu,numu,irow,icol,j,ibar,i,tau,ro,ro1,i1,mm1,n1,i2,mn1
	logical zero
	real*8 abcd(mdima,*),eps,sum(*),work(*),s,dum
	mu = p
	nu = n
   10	continue
	if (mu .eq. 0) return
	ro1 = ro
	mnu = m + nu
	numu = nu + mu
	if (m .eq. 0) goto 120
	ro1 = ro1 + 1
	irow = nu
	do 30 icol=1,sigma-1
	    do 20 j=1,ro1
		work(j) = abcd(irow+j,icol)
   20	    continue
	    call housh (work,ro1,1,eps,zero,s)
	    call tr1 (abcd,mdima,work,s,irow,ro1,icol,mnu)
	    irow = irow + 1
   30	continue
	if (sigma .eq. 0) then
	    sigma = 1
	    ro1 = ro1 - 1
	endif
	if (sigma .ne. m) then
	    do 55 icol=sigma,m
		dum = 0.0
		do 50 j=1,ro1
		    dum = dum + abcd(irow+j,icol)**2
   50		continue
		sum(icol) = dum
   55	    continue
	endif
	do 100 icol=sigma,m
	    if (icol .ne. m) then
		call pivot (sum,dum,ibar,icol,m)
		if (ibar .ne. icol) then
		    sum(ibar) = sum(icol)
		    sum(icol) = dum
		    do 70 i=1,numu
			dum = abcd(i,icol)
			abcd(i,icol) = abcd(i,ibar)
			abcd(i,ibar) = dum
   70		    continue
		endif
	    endif
	    do 90 i=1,ro1
		work(i) = abcd(irow+i,icol)
   90	    continue
	    call housh (work,ro1,1,eps,zero,s)
	    if (zero) goto 120
	    if (ro1 .eq. 1) return
	    call tr1 (abcd,mdima,work,s,irow,ro1,icol,mnu)
	    irow = irow + 1
	    ro1 = ro1 - 1
	    do 100 j=icol,m
	    sum(j) = sum(j) - abcd(irow,j)**2
  100	continue
  120	continue
	tau = ro1
	sigma = mu - tau
	if (nu .le. 0) then
	    mu = sigma
	    nu = 0
	    return
	endif
	i1 = nu + sigma
	mm1 = m + 1
	n1 = nu
	if (tau .ne. 1) then
	    do 135 i=1,tau
		dum = 0.0
		do 130 j=mm1,mnu
		    dum = dum + abcd(i1+i,j)**2
  130		continue
		sum(i) = dum
  135	    continue
	endif
	do 200 ro1=1,tau
	    ro = ro1 - 1
	    i = tau - ro
	    i2 = i + i1
	    if (i .ne. 1) then
		call pivot (sum,dum,ibar,1,i)
		if (ibar .ne. i) then
		    sum(ibar) = sum(i)
		    sum(i) = dum
		    do 150 j=mm1,mnu
			dum = abcd(i2,j)
			abcd(i2,j) = abcd(ibar+i1,j)
			abcd(ibar+i1,j) = dum
  150		    continue
		endif
	    endif
	    do 170 j=1,n1
		work(j) = abcd(i2,m+j)
  170	    continue
	    call housh (work,n1,n1,eps,zero,s)
	    if (zero) goto 210
	    if (n1 .ne. 1) then
		call tr2 (abcd,mdima,work,s,1,i2,m,n1)
		mn1 = m + n1
		call tr1 (abcd,mdima,work,s,0,n1,1,mn1)
		do 190 j=1,i
		    sum(j) = sum(j) - abcd(i1+j,mn1)**2
  190		continue
		mnu = mnu - 1
		n1 = n1 - 1
	    endif
  200	continue
	ro = tau
  210	continue
	nu = nu - ro
	mu = sigma + ro
	if (ro .ne. 0) goto 10
	return
	end
	subroutine pivot (norm,max,ibar,i1,i2)
	real*8 norm(*),max
	integer ibar,i1,i2,i
c
	ibar = i1
	max = norm(1)
	do 10 i=i1+1,i2
	    if (max .le. norm(i)) then
		max = norm(i)
		ibar = i
	    endif
   10	continue
	return
	end
	subroutine housh (work,k,j,eps,zero,s)
	real*8 work(*),s,alfa,dum1,eps
	integer k,j,i
	logical zero
c
	zero = .true.
	s = 0.0
	do 10 i=1,k
	    s = s + work(i)**2
   10	continue
	alfa = dsqrt(s)
	if (alfa .le. eps) return
	zero = .false.
	dum1 = work(j)
	if (dum1 .gt. 0.0) alfa = -alfa
	work(j) = dum1 - alfa
	s = 1.0/(s - alfa*dum1)
	return
	end
	subroutine tr1 (a,mdima,u,s,i1,i2,j1,j2)
	integer mdima,i1,i2,j1,j2,i,j
	real*8 a(mdima,*),u(*),s,inprod,y
c
	do 20 j=j1,j2
	    inprod = 0.0
	    do 10 i=1,i2
		inprod = inprod + u(i)*a(i1+i,j)
   10	    continue
	    y = inprod*s
	    do 20 i=1,i2
		a(i1+i,j) = a(i1+i,j) - u(i)*y
   20	continue
	return
	end
	subroutine tr2 (a,mdima,u,s,i1,i2,j1,j2)
	integer mdima,i1,i2,j1,j2,i,j
	real*8 a(mdima,*),u(*),s,inprod,y
c
	do 20 i=i1,i2
	    inprod = 0.0
	    do 10 j=1,j2
		inprod = inprod + u(j)*a(i,j1+j)
   10	    continue
	    y = inprod*s
	    do 20 j=1,j2
		a(i,j1+j) = a(i,j1+j) - u(j)*y
   20	continue
	return
	end
