      INTEGER FUNCTION IZAMAX(N,ZX,INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, 3/11/78.
C
      COMPLEX*16 ZX(1)
      DOUBLE PRECISION SMAX
      COMPLEX*16 ZDUM
      DOUBLE PRECISION DCABS1
C
      IZAMAX = 1
      IF(N.LE.1)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENTS NOT EQUAL TO 1
C
      IX = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      SMAX = DCABS1(ZX(1))
      IX = IX + INCX
      DO 10 I = 2,N
         IF(DCABS1(ZX(IX)).LE.SMAX) GO TO 5
         IZAMAX = IX
         SMAX = DCABS1(ZX(IX))
    5    IX = IX + INCX
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENTS EQUAL TO 1
C
   20 SMAX = DCABS1(ZX(1))
      DO 30 I = 2,N
         IF(DCABS1(ZX(I)).LE.SMAX) GO TO 30
         IZAMAX = I
         SMAX = DCABS1(ZX(I))
   30 CONTINUE
      RETURN
      END
