      SUBROUTINE ZROTG(CA,CB,C,S)
      COMPLEX*16 CA,CB,S
      DOUBLE PRECISION C
      DOUBLE PRECISION NORM,SCALE
      COMPLEX*16 ALPHA
      IF ( ZABS(CA) .NE. 0.0D0) GO TO 10
         C = 0.0D0
         S = (1.0D0,0.0D0)
         CA = CB
         GO TO 20
   10 CONTINUE
         SCALE =  ZABS(CA) +  ZABS(CB)
         NORM = SCALE*DSQRT(( ZABS(CA/DCMPLX(SCALE,0.0D0)))**2 +
     *                      ( ZABS(CB/DCMPLX(SCALE,0.0D0)))**2)
         ALPHA = CA / ZABS(CA)
         C =  ZABS(CA) / NORM
         S = ALPHA * DCONJG(CB) / NORM
         CA = ALPHA * NORM
   20 CONTINUE
      RETURN
      END
