      COMPLEX FUNCTION CDOTC(N,CX,INCX,CY,INCY)                         00000010
C                                                                       00000020
C     FORMS THE DOT PRODUCT OF TWO VECTORS, CONJUGATING THE FIRST       00000030
C     VECTOR.                                                           00000040
C     JACK DONGARRA, LINPACK,  3/11/78.                                 00000050
C                                                                       00000060
      COMPLEX CX(1),CY(1),CTEMP                                         00000070
      INTEGER I,INCX,INCY,IX,IY,N                                       00000080
C                                                                       00000090
      CTEMP = (0.0,0.0)                                                 00000100
      CDOTC = (0.0,0.0)                                                 00000110
      IF(N.LE.0)RETURN                                                  00000120
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000130
C                                                                       00000140
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                00000150
C          NOT EQUAL TO 1                                               00000160
C                                                                       00000170
      IX = 1                                                            00000180
      IY = 1                                                            00000190
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000200
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000210
      DO 10 I = 1,N                                                     00000220
        CTEMP = CTEMP + CONJG(CX(IX))*CY(IY)                            00000230
        IX = IX + INCX                                                  00000240
        IY = IY + INCY                                                  00000250
   10 CONTINUE                                                          00000260
      CDOTC = CTEMP                                                     00000270
      RETURN                                                            00000280
C                                                                       00000290
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            00000300
C                                                                       00000310
   20 DO 30 I = 1,N                                                     00000320
        CTEMP = CTEMP + CONJG(CX(I))*CY(I)                              00000330
   30 CONTINUE                                                          00000340
      CDOTC = CTEMP                                                     00000350
      RETURN                                                            00000360
      END                                                               00000370
