      COMPLEX FUNCTION CDOTU(N,CX,INCX,CY,INCY)                         00000010
C                                                                       00000020
C     FORMS THE DOT PRODUCT OF TWO VECTORS.                             00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      COMPLEX CX(1),CY(1),CTEMP                                         00000060
      INTEGER I,INCX,INCY,IX,IY,N                                       00000070
C                                                                       00000080
      CTEMP = (0.0,0.0)                                                 00000090
      CDOTU = (0.0,0.0)                                                 00000100
      IF(N.LE.0)RETURN                                                  00000110
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000120
C                                                                       00000130
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                00000140
C          NOT EQUAL TO 1                                               00000150
C                                                                       00000160
      IX = 1                                                            00000170
      IY = 1                                                            00000180
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000190
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000200
      DO 10 I = 1,N                                                     00000210
        CTEMP = CTEMP + CX(IX)*CY(IY)                                   00000220
        IX = IX + INCX                                                  00000230
        IY = IY + INCY                                                  00000240
   10 CONTINUE                                                          00000250
      CDOTU = CTEMP                                                     00000260
      RETURN                                                            00000270
C                                                                       00000280
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            00000290
C                                                                       00000300
   20 DO 30 I = 1,N                                                     00000310
        CTEMP = CTEMP + CX(I)*CY(I)                                     00000320
   30 CONTINUE                                                          00000330
      CDOTU = CTEMP                                                     00000340
      RETURN                                                            00000350
      END                                                               00000360
