      INTEGER FUNCTION ICAMAX(N,CX,INCX)                                00000010
C                                                                       00000020
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.            00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      COMPLEX CX(1)                                                     00000060
      REAL SMAX                                                         00000070
      INTEGER I,INCX,IX,N                                               00000080
      COMPLEX ZDUM                                                      00000090
      REAL CABS1                                                        00000100
      CABS1(ZDUM) = ABS(REAL(ZDUM)) + ABS(AIMAG(ZDUM))                  00000110
C                                                                       00000120
      ICAMAX = 0                                                        00000130
      IF( N .LT. 1 ) RETURN                                             00000140
      ICAMAX = 1                                                        00000150
      IF(N.EQ.1)RETURN                                                  00000160
      IF(INCX.EQ.1)GO TO 20                                             00000170
C                                                                       00000180
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000190
C                                                                       00000200
      IX = 1                                                            00000210
      SMAX = CABS1(CX(1))                                               00000220
      IX = IX + INCX                                                    00000230
      DO 10 I = 2,N                                                     00000240
         IF(CABS1(CX(IX)).LE.SMAX) GO TO 5                              00000250
         ICAMAX = I                                                     00000260
         SMAX = CABS1(CX(IX))                                           00000270
    5    IX = IX + INCX                                                 00000280
   10 CONTINUE                                                          00000290
      RETURN                                                            00000300
C                                                                       00000310
C        CODE FOR INCREMENT EQUAL TO 1                                  00000320
C                                                                       00000330
   20 SMAX = CABS1(CX(1))                                               00000340
      DO 30 I = 2,N                                                     00000350
         IF(CABS1(CX(I)).LE.SMAX) GO TO 30                              00000360
         ICAMAX = I                                                     00000370
         SMAX = CABS1(CX(I))                                            00000380
   30 CONTINUE                                                          00000390
      RETURN                                                            00000400
      END                                                               00000410
