      INTEGER FUNCTION IDAMAX(N,DX,INCX)                                00000010
C                                                                       00000020
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.            00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      DOUBLE PRECISION DX(1),DMAX                                       00000060
      INTEGER I,INCX,IX,N                                               00000070
C                                                                       00000080
      IDAMAX = 0                                                        00000090
      IF( N .LT. 1 ) RETURN                                             00000100
      IDAMAX = 1                                                        00000110
      IF(N.EQ.1)RETURN                                                  00000120
      IF(INCX.EQ.1)GO TO 20                                             00000130
C                                                                       00000140
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000150
C                                                                       00000160
      IX = 1                                                            00000170
      DMAX = DABS(DX(1))                                                00000180
      IX = IX + INCX                                                    00000190
      DO 10 I = 2,N                                                     00000200
         IF(DABS(DX(IX)).LE.DMAX) GO TO 5                               00000210
         IDAMAX = I                                                     00000220
         DMAX = DABS(DX(IX))                                            00000230
    5    IX = IX + INCX                                                 00000240
   10 CONTINUE                                                          00000250
      RETURN                                                            00000260
C                                                                       00000270
C        CODE FOR INCREMENT EQUAL TO 1                                  00000280
C                                                                       00000290
   20 DMAX = DABS(DX(1))                                                00000300
      DO 30 I = 2,N                                                     00000310
         IF(DABS(DX(I)).LE.DMAX) GO TO 30                               00000320
         IDAMAX = I                                                     00000330
         DMAX = DABS(DX(I))                                             00000340
   30 CONTINUE                                                          00000350
      RETURN                                                            00000360
      END                                                               00000370
