      REAL FUNCTION SCASUM(N,CX,INCX)                                   00000010
C                                                                       00000020
C     TAKES THE SUM OF THE ABSOLUTE VALUES OF A COMPLEX VECTOR AND      00000030
C     RETURNS A SINGLE PRECISION RESULT.                                00000040
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000050
C                                                                       00000060
      COMPLEX CX(1)                                                     00000070
      REAL STEMP                                                        00000080
      INTEGER I,INCX,N,NINCX                                            00000090
C                                                                       00000100
      SCASUM = 0.0E0                                                    00000110
      STEMP = 0.0E0                                                     00000120
      IF(N.LE.0)RETURN                                                  00000130
      IF(INCX.EQ.1)GO TO 20                                             00000140
C                                                                       00000150
C        CODE FOR INCREMENT NOT EQUAL TO 1                              00000160
C                                                                       00000170
      NINCX = N*INCX                                                    00000180
      DO 10 I = 1,NINCX,INCX                                            00000190
        STEMP = STEMP + ABS(REAL(CX(I))) + ABS(AIMAG(CX(I)))            00000200
   10 CONTINUE                                                          00000210
      SCASUM = STEMP                                                    00000220
      RETURN                                                            00000230
C                                                                       00000240
C        CODE FOR INCREMENT EQUAL TO 1                                  00000250
C                                                                       00000260
   20 DO 30 I = 1,N                                                     00000270
        STEMP = STEMP + ABS(REAL(CX(I))) + ABS(AIMAG(CX(I)))            00000280
   30 CONTINUE                                                          00000290
      SCASUM = STEMP                                                    00000300
      RETURN                                                            00000310
      END                                                               00000320
