      COMPLEX*16 FUNCTION ZDOTU(N,ZX,INCX,ZY,INCY)                      00000010
C                                                                       00000020
C     FORMS THE DOT PRODUCT OF A VECTOR.                                00000030
C     JACK DONGARRA, 3/11/78.                                           00000040
C                                                                       00000050
      COMPLEX*16 ZX(1),ZY(1),ZTEMP                                      00000060
      ZTEMP = (0.0D0,0.0D0)                                             00000070
      ZDOTU = (0.0D0,0.0D0)                                             00000080
      IF(N.LE.0)RETURN                                                  00000090
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000100
C                                                                       00000110
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                00000120
C          NOT EQUAL TO 1                                               00000130
C                                                                       00000140
      IX = 1                                                            00000150
      IY = 1                                                            00000160
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000170
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000180
      DO 10 I = 1,N                                                     00000190
        ZTEMP = ZTEMP + ZX(IX)*ZY(IY)                                   00000200
        IX = IX + INCX                                                  00000210
        IY = IY + INCY                                                  00000220
   10 CONTINUE                                                          00000230
      ZDOTU = ZTEMP                                                     00000240
      RETURN                                                            00000250
C                                                                       00000260
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            00000270
C                                                                       00000280
   20 DO 30 I = 1,N                                                     00000290
        ZTEMP = ZTEMP + ZX(I)*ZY(I)                                     00000300
   30 CONTINUE                                                          00000310
      ZDOTU = ZTEMP                                                     00000320
      RETURN                                                            00000330
      END                                                               00000340
