      SUBROUTINE  ZDSCAL(N,DA,ZX,INCX)                                  00000010
C                                                                       00000020
C     SCALES A VECTOR BY A CONSTANT.                                    00000030
C    JACK DONGARRA, 3/11/78.                                            00000040
C                                                                       00000050
      COMPLEX*16 ZX(1)                                                  00000060
      DOUBLE PRECISION DA                                               00000070
      IF(N.LE.0)RETURN                                                  00000080
      IF(INCX.EQ.1)GO TO 20                                             00000090
C                                                                       00000100
C        CODE FOR INCREMENTS NOT EQUAL TO 1                             00000110
C                                                                       00000120
      IX = 1                                                            00000130
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000140
      DO 10 I = 1,N                                                     00000150
        ZX(IX) = DCMPLX(DA,0.0D0)*ZX(IX)                                00000160
        IX = IX + INCX                                                  00000170
   10 CONTINUE                                                          00000180
      RETURN                                                            00000190
C                                                                       00000200
C        CODE FOR INCREMENTS EQUAL TO 1                                 00000210
C                                                                       00000220
   20 DO 30 I = 1,N                                                     00000230
        ZX(I) = DCMPLX(DA,0.0D0)*ZX(I)                                  00000240
   30 CONTINUE                                                          00000250
      RETURN                                                            00000260
      END                                                               00000270
