      SUBROUTINE  ZSWAP (N,ZX,INCX,ZY,INCY)                             00000010
C                                                                       00000020
C     INTERCHANGES TWO VECTORS.                                         00000030
C     JACK DONGARRA, 3/11/78.                                           00000040
C                                                                       00000050
      COMPLEX*16 ZX(1),ZY(1),ZTEMP                                      00000060
C                                                                       00000070
      IF(N.LE.0)RETURN                                                  00000080
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000090
C                                                                       00000100
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL       00000110
C         TO 1                                                          00000120
C                                                                       00000130
      IX = 1                                                            00000140
      IY = 1                                                            00000150
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000160
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000170
      DO 10 I = 1,N                                                     00000180
        ZTEMP = ZX(IX)                                                  00000190
        ZX(IX) = ZY(IY)                                                 00000200
        ZY(IY) = ZTEMP                                                  00000210
        IX = IX + INCX                                                  00000220
        IY = IY + INCY                                                  00000230
   10 CONTINUE                                                          00000240
      RETURN                                                            00000250
C                                                                       00000260
C       CODE FOR BOTH INCREMENTS EQUAL TO 1                             00000270
   20 DO 30 I = 1,N                                                     00000280
        ZTEMP = ZX(I)                                                   00000290
        ZX(I) = ZY(I)                                                   00000300
        ZY(I) = ZTEMP                                                   00000310
   30 CONTINUE                                                          00000320
      RETURN                                                            00000330
      END                                                               00000340
