      INTEGER IBAND, IWORK(166),IDEV, ITRACE, I, J, NWKMON, NPTS, NPDE,
     -    NV, ITOL, NSTEPS, NEQN, IFUN, IJAC, M, LIW, NITER, ISET, IRES,
     -    NXI, INFORM(213), NWKDRV, NWKJAC, N, NOP, IPMINF, NRWK
      DOUBLE PRECISION  X(81), U(2,81), WORK(900), XI, CONST, STPRAT,
     -    TOUT, ABS, REL, RESWK(500), WKMON(800), YDOT(161),
     -    TS, WKJAC(10000), YSAVE(161,15)
      LOGICAL REMESH
      CHARACTER*6 SNORM
      EXTERNAL PREPJB, SOLSB, SPGEAR, JAC, MVMESH, SKLRES
      COMMON /SDEV2/ ITRACE,IDEV
C COMMON MESHIN USED BY SUBROUTINES INITSK AND MVMESH
C COMMON MESHTI USED BY SUBROUTINE MVMESH FOR REMESHING IN TIME INFO
      COMMON /MESHIN/ CONST, STPRAT, IPMINF, NOP
      COMMON /MESHTI/ TOUT, REMESH, NRMESH, ICOUNT
      NPDE = 2
C     CALL ERRSET ( 208, 256, -1, -1, 0) --  IBM ONLY TO DISABLE U/FLOW.
      ITRACE = 1
      IDEV   = 4
      NPTS = 41
      NEQN = NPDE*NPTS
      M = 0
      NWKMON = 800
      ITOL = 1
      ABS = 1.0D-4
      REL = 1.0D-4
C
C  INITIALISE THE DISCRETISATION WORKSPACE AND THE REMESH INFO
C  (VARIABLE NO. POINTS OPTION THEN SET NOP=0 ELSE NOP=NPTS)
      REMESH = .TRUE.
      NOP=NPTS
      CONST=5.0D-1
      STPRAT=3.0D0
      IPMINF=0
C NRMESH DICTATES HOW OFTEN REMESH :
C      =1 THEN REMESHES EVERY TIME STEP WHEN MVMESH ROUTINE CALLED
C      =2                     2ND TIME STEP, ETC....
C      =0 THEN REMESHES AT CURRENT TIME TOUT BY THE CALL TO MVMESH WITH
C         INFORM(2)=4 AND WORK(1) SET TO CURRENT TOUT. IF THE SOLUTION
C          PROFILE CHANGES RAPIDLY THEN SET TOUT ACCORDINGLY.
      NRMESH=2
C ICOUNT USED TO COUNT UP TO NRMESH SO JUST INITIALISE TO ZERO
      ICOUNT=0
      NV = 0
      NXI = 0
      XI = 0.0D0
      IRES = 1
      NRWK = 500
      X(1) = 0.0D0
      X(NPTS) = 10.0D0
      DO 10 I = 2, NPTS-1
 10      X(I) = X(1) + (I-1)*(X(NPTS) - X(1)) / (NPTS-1)
         TS = 0.00D0
      CALL INITSK( NEQN, NPDE, NPTS, X, U, RESWK, NRWK, M, TS, IBAND,
     1               IRES, .TRUE., NPTS, NV, NXI, XI)
      IF(IRES .LT. 0)GOTO 106
C
C  PASS THE INTEGRATION PARAMETERS INTO INFORM AND SETUP THE INTEGRATOR
C
      N = NEQN
      INFORM(1) = 0
      INFORM(2) = 1
      INFORM(3) = 1
      DO 50 I = 3,14
 50      INFORM(I) = 0
      ISET = 0
      CALL BDFSET(8, ISET, 5, 2 , .FALSE.)
      IF(ISET .LT. 0)GOTO 1000
      NWKDRV = 900
      NYSAVE = 161
      NWKJAC = 10000
      LIW = 166
C
C   SET UP THE PARAMETERS FOR THE LINEAR ALGEBRA INITIALISATION CALL
      LINALG = 1
      IWORK(1) = IBAND
      IWORK(2) = IBAND
      ISET     = 0
      CALL MATSET( LINALG, NEQN, IWORK, IWORK(2), NWKJAC, LIW, ISET)
      IF(ISET .LT. 0)GOTO 1000
C**********************************************************************
C                    CALL SPRINT
      TS = 0.0D0
      TOUT = 0.28D0
100   SNORM = 'AVERL2'
      CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPGEAR,YSAVE, NYSAVE
     2    ,PREPJB, WKJAC, NWKJAC, IWORK, JAC, SOLSB,
     3     MVMESH, WKMON, NWKMON)
C   PASS MESH AND STATS BACK ACROSS.
C
79     IRES = 2
       CALL INITSK( NEQN,NPDE, NPTS, X, U, RESWK, NRWK, M, TS, IBAND,
     1              2, .TRUE. , NPTS, NV, NXI, XI)
       IFUN = INFORM(7)
       IJAC = INFORM(8)
       NSTEPS = INFORM(6)
       NITER = INFORM(11)
       WRITE(IDEV,81)TOUT,INFORM(1)
81     FORMAT('  SOL AT',D12.4/' INFORM(1) =',I3)
       WRITE(IDEV,80)(X(I),I = 1,NPTS,5)
       DO 70 J=1,NPDE
70      WRITE(IDEV,80)(U(J,I),I=1,NPTS,5)
80      FORMAT(9(D11.3))
106    CONTINUE
       IF(INFORM(1) .EQ. 2)THEN
          IF(TOUT .GE. 2.8D0)GOTO 1000
          TOUT = TOUT + 0.28D0
          GOTO 100
       END IF
 1000 CONTINUE
      WRITE(IDEV,2000)IFUN,IJAC,NITER, NSTEPS
 2000 FORMAT(' FUN=',I5,' IJAC=',I5,' NITER=',I5,' NSTEPS=',I5)
      STOP
      END
C**********************************************************************
C        PROBLEM DESCRIPTION ROUTINES
C**********************************************************************
       SUBROUTINE UINIT( NPDE, NPTS, X, U)
C      ROUTINE FOR P.D.E. INITIAL VALUES.
       INTEGER NPDE, NPTS
       DOUBLE PRECISION X(NPTS), U(NPDE,NPTS)
       DO 10 I = 1,NPTS
          U(1,I) = 1.0D0
 10       U(2,I) = 0.0D0
       RETURN
       END
       SUBROUTINE SPDEF1(T, X, NPDE, U, DUDX, C, F, R, NV, V,VD,L)
C      ROUTINE TO DESCRIBE THE BODY OF THE P.D.E.
       INTEGER NPDE, J, NV, L
       DOUBLE PRECISION T, KV, X, U(NPDE), DUDX(NPDE),
     1            C(NPDE,NPDE), F(NPDE), R(NPDE), V, VD
          DO 9 J = 1,NPDE
             C(J,J) = 1.0D0
 9           R(J) = DUDX(J)
          KV = 14.6D0 * DEXP( 4.0D0 - 4.0D0/(U(2) + 0.01D0))
          F(1) =   KV * U(1)
          F(2) = - KV * U(1)
       RETURN
       END
       SUBROUTINE BNDR( T, BETA, GAMMA, U, UX, NPDE, LEFT, NV, V, VD,L)
C      BOUNDARY CONDITIONS ROUTINE
       INTEGER NPDE, I,NV
       DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), HPI, V, VD
     1                    ,UX(NPDE)
       LOGICAL LEFT
       HPI = 3.14159265350D0 * 0.5D0 / 0.95D0
       DO 10 I = 1,NPDE
          BETA(I) = 1.0D0
          GAMMA(I) = 0.0D0
 10    CONTINUE
       IF(LEFT) THEN
          IF(T .LE. 0.05)THEN
             GAMMA(2) = -T/0.05D0
          ELSE IF(T .LE. 1.0)THEN
             GAMMA(2) = -DCOS(HPI*(T-0.05D0))
          END IF
       END IF
       RETURN
       END
C      DUMMY ROUTINES FOR NON-EXISTANT O.D.E. PART
       SUBROUTINE SVINIT
       RETURN
       END
       SUBROUTINE SODEFN
       RETURN
       END
      SUBROUTINE EVNRMF( TIME, NIP, NPDE, X, U, R, MAXNPT, FMON)
C**********************************************************************
C     EXAMPLE MONITOR  FUNCTION ROUTINE FOR REMESHING.
C     R(J,I) CONTAINS THE FLUX FOR JTH P.D.E. AT POINT Y(I)
C        WHERE Y(1) = X(1) , Y(NIP+1) = X(NIP)
C              Y(I) =(X(I+1) - X(I)) * 0.5   I = 2,..., NIP
C     THE MONITOR FUNCTION IS RETURNED IN THE ARRAY FMON
C**********************************************************************
      INTEGER NIP, NPDE, MAXNPT, I, J, K, L
      DOUBLE PRECISION U(NPDE,1), X(NIP), SUM,FMON(NIP), TIME,
     1                 R(NPDE,1),  DRDX, H
      IF(TIME .EQ. 0.0D0)GOTO 100
      DO 10 I=1,NIP
        K = MAX0(1,I-1)
        L = MIN0(NIP,I+1)
        H = (X(L) - X(K)) * 0.5D0
        SUM=0.0D0
        DO 5 J=1,NPDE
C 1ST DERIV
C          DRDX = R(J,I)
C 2ND DERIV
           DRDX = (R(J,I+1) - R(J,I)) / H
    5      SUM = SUM + DRDX**2
        FMON(I)=DSQRT(SUM)
   10 CONTINUE
      RETURN
100   CONTINUE
      DO 200 I = 1,NP
200     FMON(I) = 0.0D0
      RETURN
      END
